SystemOrganization addCategory: #'PharoBot-UI'!

TransformationMorph subclass: #RobotMorph
	instanceVariableNames: 'mundo direccion estado_pincelArriba estado_pincelAbajo estado_pincelActual ultimaPosicion bateria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!RobotMorph class methodsFor: 'crear instancia' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
"Luego de crear un robot hay que mandarle el mensaje 'inicializarRobot' "

crearRobotConMundo: unMundo conBateria: unaBateria

|nuevoRobot|

nuevoRobot:= self new.
nuevoRobot mundo: unMundo.
nuevoRobot bateria: unaBateria.
unMundo robot: nuevoRobot.
nuevoRobot position: (nuevoRobot mundo position x + (nuevoRobot mundo extent x / 2) ) @ (nuevoRobot mundo position y + (nuevoRobot mundo extent y / 2)).
^ nuevoRobot openInWorld .
! !

!RobotMorph methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
bajarPincel

self estado_pincelActual: self estado_pincelAbajo.! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
bateria
	^ bateria! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
bateria: anObject
	bateria := anObject! !

!RobotMorph methodsFor: 'caminos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
borrarCaminos

self mundo caminos do:  [:elem | elem delete.].
self mundo caminos: Set new.! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
direccion
	^ self angle radiansToDegrees .! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
direccion: unAngulo
	self angle: unAngulo degreesToRadians.
	self position: self ultimaPosicion .
! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelAbajo
	^ estado_pincelAbajo! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelAbajo: anObject
	estado_pincelAbajo := anObject! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelActual
	^ estado_pincelActual! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelActual: anObject
	estado_pincelActual := anObject! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelArriba
	^ estado_pincelArriba! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelArriba: anObject
	estado_pincelArriba := anObject! !

!RobotMorph methodsFor: 'inicializar' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
inicializarRobot

|piezaUno piezaDos piezaTres piezaCuatro piezaCinco pixel posInicial|
"Cuerpo"
piezaUno:= BorderedMorph new.
piezaUno extent: 20@40.
piezaUno color: (Color lightGreen  ).
piezaUno borderColor: Color green.
piezaUno openInWorld .
piezaUno position: self position. 
self asFlexOf: piezaUno.

"Ojo izquierdo"
piezaDos:= CircleMorph new.
piezaDos extent: 10@10.
piezaDos color: (Color blue alpha: 0.5).
piezaDos position: (piezaUno position x + 7) @ (piezaUno position y + 5).
piezaDos openInWorld .
piezaUno addMorph: piezaDos.

"Ojo derecho"
piezaTres:= CircleMorph new.
piezaTres extent: 10@10.
piezaTres color: (Color blue alpha: 0.5).
piezaTres position: (piezaUno position x + 7) @ (piezaUno position y + 23).
piezaTres openInWorld .
piezaUno addMorph: piezaTres.

"Bolita del ojo 1"
piezaCuatro:= CircleMorph new.
piezaCuatro extent: 5@5.
piezaCuatro color: Color black .
piezaCuatro position: (piezaDos position x + 5) @ (piezaDos position y + 3) .
piezaCuatro openInWorld .
piezaDos addMorph: piezaCuatro.

"Bolita del ojo 2"
piezaCinco:= CircleMorph new.
piezaCinco extent: 5@5.
piezaCinco color: Color black .
piezaCinco position: (piezaTres position x + 5) @ (piezaTres position y + 3) .
piezaCinco openInWorld .
piezaTres addMorph: piezaCinco.

"Cuerpo del robot "

posInicial:= (piezaUno position x + 20) @ (piezaUno position y).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y + 2.5).].

posInicial:= (piezaUno position x + 20) @ (piezaUno position y + 37).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y - 2.5).].

" Brazos del robot  y pincel"

posInicial:= (piezaUno position x + 26) @ (piezaUno position y + 6).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x - 1) @ (posInicial y - 2.5).].

posInicial:= (piezaUno position x + 26) @ (piezaUno position y + 31).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x - 1) @ (posInicial y + 2.5).].

"Pies"

posInicial:= (piezaUno position x + 37) @ (piezaUno position y + 17).
(4)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y - 2).].

posInicial:= (piezaUno position x + 37) @ (piezaUno position y + 17).
(4)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y + 2).].

self ultimaPosicion: self position.

"Se une el robot con su mundo"
self mundo addMorph: self.


! !

!RobotMorph methodsFor: 'movimiento' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mover: unaLongitud 

self estado_pincelActual mover: unaLongitud.! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mundo
	^ mundo! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mundo: anObject
	mundo := anObject! !

!RobotMorph methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelAbajo 

^ self estado_pincelActual pincelAbajo .! !

!RobotMorph methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelArriba  

^ self estado_pincelActual pincelArriba .! !

!RobotMorph methodsFor: 'inicializar' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
reasignarRobot 

"Se une el robot con su mundo"
self mundo addMorph: self.! !

!RobotMorph methodsFor: 'bateria' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
recargarBateria

self bateria recargar .! !

!RobotMorph methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
subirPincel

self estado_pincelActual: self estado_pincelArriba .! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
ultimaPosicion
	^ ultimaPosicion! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
ultimaPosicion: anObject
	ultimaPosicion := anObject! !

Morph subclass: #Mundo
	instanceVariableNames: 'robot caminos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!Mundo class methodsFor: 'crear instancia' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
"El tamao es pasado de la siguiente manera    140 @ 140 donde los valores de X e Y deben ser multiplos de 70"

crearMundo: unaSuperficie

|mundo nroRepeticionesEnX nroRepeticionesEnY posicionActual cuadriculaNueva|

"Chequear datos ingresados"

((unaSuperficie x isDivisibleBy: 70) & (unaSuperficie y isDivisibleBy: 70))
ifFalse: [ self error: 'Los valores ingresados deben ser multiplos de 70'].

mundo:= self new.
mundo color: (Color black alpha: 0.3).
mundo extent: unaSuperficie.

"Cuadriculado"

nroRepeticionesEnX:= mundo extent x // 70.
nroRepeticionesEnY:= mundo extent y // 70.
posicionActual:= mundo position.

(nroRepeticionesEnY) timesRepeat: 
[(nroRepeticionesEnX) timesRepeat: [ cuadriculaNueva:= CuadriculaDeMundo crearCuadriculaDeMundo.	
								cuadriculaNueva position: posicionActual.
								mundo addMorph: cuadriculaNueva.
								posicionActual:= (posicionActual x + 70) @ (posicionActual y)].
							
	posicionActual:= (posicionActual x - (nroRepeticionesEnX * 70) @ (posicionActual y + 70)) ].

mundo caminos: Set new.

^ mundo! !

!Mundo methodsFor: 'caminos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
actualizarCaminos: unMundoNuevo

self caminos do: [ :punto | unMundoNuevo addMorph: punto.].
self caminos do: [ :punto | unMundoNuevo caminos add: punto.]! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
ampliarParaMoverEnX: unaLongitud delRobot: unRobot

((unRobot left - unRobot mundo left)abs <= unaLongitud)
"Se extiende al oeste"
ifTrue: [ self extenderAlOeste: unaLongitud.
		self robot reasignarRobot .] .

(((unRobot left + unRobot extent x)-(unRobot mundo left + unRobot mundo extent x))abs <= unaLongitud) 
"Se extiende al este"
ifTrue: [ self extenderAlEste: unaLongitud.
		self robot reasignarRobot . ].! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
ampliarParaMoverEnY: unaLongitud delRobot: unRobot

((unRobot top - unRobot mundo top)abs <= unaLongitud) 
"Se extiende al norte"
ifTrue: [ self extenderAlNorte:  unaLongitud.
		self robot reasignarRobot  .] .

(((unRobot top + unRobot extent y)-(unRobot mundo top + unRobot mundo extent y))abs <= unaLongitud)
"Se extiende al sur"
ifTrue: [ self extenderAlSur:  unaLongitud.
		self robot reasignarRobot  .]! !

!Mundo methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
caminos
	^ caminos! !

!Mundo methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
caminos: anObject
	caminos := anObject! !

!Mundo methodsFor: 'caminos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
dibujarLineaDesde: ptoInicio conLongitud: unaLongitud conInclinacion: unAngulo

|ptoActual longEnX longEnY puntoDibujado|

ptoActual:= ptoInicio.
longEnX:= self robot angle cos * 2.
longEnY:= self robot angle sin * 2.


(unaLongitud // 2) timesRepeat: 
[ 	puntoDibujado:= self dibujarPunto: ptoActual.
	self addMorph: puntoDibujado.
	ptoActual:= (ptoActual x + longEnX) @ (ptoActual y - longEnY).]

! !

!Mundo methodsFor: 'caminos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
dibujarPunto: posicion

|nuevoPunto|

nuevoPunto:= Morph new.
nuevoPunto extent: 2@2.
nuevoPunto position: posicion.
self caminos add: nuevoPunto.
^ nuevoPunto openInWorld .! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
extenderAlEste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: self position.
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
extenderAlNorte: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: (self position x) @ (self position y - (cuadriculasAExtender * 70)).
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
extenderAlOeste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: (self position x - (cuadriculasAExtender * 70) @ (self position y)).
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
extenderAlSur: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: self position.
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
robot
	^ robot! !

!Mundo methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
robot: anObject
	robot := anObject! !

BorderedMorph subclass: #CuadriculaDeMundo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!CuadriculaDeMundo class methodsFor: 'crear instancia' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
crearCuadriculaDeMundo

|cuadricula|
cuadricula:= BorderedMorph new.
cuadricula extent: 70@70.
cuadricula borderWidth: 1.
cuadricula color: (Color black alpha: 0).
^ cuadricula openInWorld .! !

Workspace subclass: #PharoBotWorkspaceAdaptor
	instanceVariableNames: 'workspaceModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotWorkspaceAdaptor commentStamp: '<historical>' prior: 0!
I adapt the Pharo workspace in order to add more features used in PharoBot, such as notifying changes, adding variables, and so on.!

!PharoBotWorkspaceAdaptor methodsFor: 'bindings' stamp: 'NahuelGarbezza 7/31/2012 13:31'!
bindingOf: aString

	(self hasBindingOf: aString)
		ifFalse: [self workspaceModel variableBindings at: aString put: nil].
	
	^self workspaceModel variableBindings associationAt: aString! !

!PharoBotWorkspaceAdaptor methodsFor: 'bindings' stamp: 'NahuelGarbezza 7/29/2012 22:18'!
browseBindings

	self workspaceModel variableBindings inspect! !

!PharoBotWorkspaceAdaptor methodsFor: 'bindings' stamp: 'NahuelGarbezza 7/31/2012 13:27'!
hasBindingOf: aString

	^self workspaceModel hasBindingOf: aString! !

!PharoBotWorkspaceAdaptor methodsFor: 'bindings' stamp: 'NahuelGarbezza 7/31/2012 13:31'!
initializeBindings

	self workspaceModel initializeBindings.! !

!PharoBotWorkspaceAdaptor methodsFor: 'bindings' stamp: 'NahuelGarbezza 7/31/2012 13:31'!
setBindings: aDictionary

	self workspaceModel variableBindings: aDictionary.! !

!PharoBotWorkspaceAdaptor methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/29/2012 19:56'!
workspaceModel

	^workspaceModel! !

!PharoBotWorkspaceAdaptor methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/29/2012 19:56'!
workspaceModel: aPharoBotWorkspace

	workspaceModel := aPharoBotWorkspace! !

Object subclass: #EstadoDelRobot
	instanceVariableNames: 'robot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!EstadoDelRobot class methodsFor: 'crear instancia' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
"Luego de crear un EstadoDelRobot  hay que mandarle el mensaje inicializarEstadoEnRobot "

crearEstado: unRobot

|estado|

estado:= self new.
estado robot: unRobot.
^ estado.! !

!EstadoDelRobot methodsFor: 'inicializacion' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
inicializarEstadoEnRobot

"El robot comienza con un EsadoActual = Estado_PincelArriba"
self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'movimientos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mover: unaLongitud

|movimientoEnX movimientoEnY|

(self robot bateria carga < unaLongitud)
ifTrue: [self error: 'Debe recargar la bateria para realizar el movimiento'].

movimientoEnX:= self robot angle cos * unaLongitud.
movimientoEnY:= self robot angle sin * unaLongitud.

"Movimiento en x"

self robot position: (self robot position x + movimientoEnX) @ (self robot position y).
self robot mundo ampliarParaMoverEnX: movimientoEnX abs delRobot: self robot.

"Movimiento en y"

self robot position: (self robot position x) @ (self robot position y - movimientoEnY).
self robot mundo ampliarParaMoverEnY: movimientoEnY abs delRobot: self robot.
"Actualizo ultima posicion"

self robot ultimaPosicion: self robot position .

self robot bateria carga: self robot bateria carga - unaLongitud.

! !

!EstadoDelRobot methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelAbajo

self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelArriba

self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
robot
	^ robot! !

!EstadoDelRobot methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
robot: anObject
	robot := anObject! !

EstadoDelRobot subclass: #Estado_PincelAbajo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!Estado_PincelAbajo methodsFor: 'inicializacion' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
inicializarEstadoEnRobot 

self robot estado_pincelAbajo: self.! !

!Estado_PincelAbajo methodsFor: 'movimientos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mover: unaLongitud

|posicionInicial|

posicionInicial:= self robot ultimaPosicion.

super mover: unaLongitud.
self robot mundo dibujarLineaDesde: posicionInicial conLongitud: unaLongitud conInclinacion: self robot angle.! !

!Estado_PincelAbajo methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelAbajo 

^ true.! !

!Estado_PincelAbajo methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelArriba 

^ false.! !

EstadoDelRobot subclass: #Estado_PincelArriba
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!Estado_PincelArriba methodsFor: 'inicializacion' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
inicializarEstadoEnRobot 

self robot estado_pincelArriba: self.
self robot estado_pincelActual: self.! !

!Estado_PincelArriba methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelAbajo  

^ false.! !

!Estado_PincelArriba methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelArriba 

^ true.! !

Object subclass: #PharoBotIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotIcons commentStamp: '<historical>' prior: 0!
Contains all the icons and figures used in the UI.!

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:46'!
addClassIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:38'!
addMethodIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:37'!
addWorkspaceIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:32'!
codeBrowserIcon

	^ThemeIcons projectIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 19:32'!
defaultIcon

	^ThemeIcons smallQuestionIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:47'!
exportClassIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:39'!
exportWorkspaceIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:47'!
importClassIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:39'!
importWorkspaceIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:40'!
inspectReferenceIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 19:20'!
quitIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:46'!
removeClassIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 19:20'!
removeMethodIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:40'!
removeReferenceIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:38'!
removeWorkspaceIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:49'!
renameClassIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 19:20'!
renameMethodIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:38'!
renameWorkspaceIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 19:21'!
robotImage

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 19:21'!
saveImageIcon

	self flag: #TODO.
	^self defaultIcon! !

!PharoBotIcons class methodsFor: 'as yet unclassified' stamp: 'NahuelGarbezza 8/26/2012 18:36'!
workspaceAreaIcon

	^ThemeIcons objectsIcon! !

Object subclass: #PharoBotUI
	instanceVariableNames: 'tabGroup builder environment methodBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotUI class methodsFor: 'world menu' stamp: 'NahuelGarbezza 7/14/2012 19:54'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #PharoBot)
		order: 4;
		target: self.
	
	(aBuilder group: #PharoBotPracticas)
		parent: #PharoBot;
		with: [
			(aBuilder item: #'Practica 1')
				action:[ PharoBotUIWithObjects open ].
			(aBuilder item: #'Practica 2')
				action: [ PharoBotUIWithClasses open ]].! !

!PharoBotUI class methodsFor: 'ui opening' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
open

	^self new open! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:12'!
addNewInstanceMethod

	"Popup pidiendo el nombre del metodo, y setearlo como seleccionado."
	"Por defecto, compilarlo con el nombre y un comentario a modo de template"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'ui building - morphic' stamp: 'NahuelGarbezza 8/26/2012 18:29'!
buildCodeBrowserLabel

	^builder newRow: {
		builder newImage: PharoBotIcons codeBrowserIcon.
		builder newLabel: 'Codigo'.
	}! !

!PharoBotUI methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildCodeBrowserPanel

	|browser|
	browser := GLMTabulator new.
	self buildLayoutFor: browser.
	self buildTransitionsFor: browser.
	^self startBrowser: browser.! !

!PharoBotUI methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildLayoutFor: browser

	self subclassResponsibility! !

!PharoBotUI methodsFor: 'ui building - morphic' stamp: 'NahuelGarbezza 8/26/2012 18:35'!
buildMainButtons

	self flag: #TODO.
	"Agregar iconos para ambos botones, apuntar a
		PharoBotIcons >> #saveImageIcon y a 	
		PharoBotIcons >> #quitIcon"
	
	^builder newRow: {
		builder
			newButtonFor: self
			action: #saveImage
			label: 'Guardar Ambiente'
			help: 'Guarda el estado del ambiente para ser cargado luego'.
		builder
			newButtonFor: self
			action: #quit
			label: 'Salir'
			help: 'Sale del ambiente'.
	}.! !

!PharoBotUI methodsFor: 'ui building - morphic' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildMainPanel

	^(builder := UITheme builder) newColumn: {
		self buildMainTabGroup.
		self buildMainButtons.
	}.! !

!PharoBotUI methodsFor: 'ui building - morphic' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildMainTabGroup

	^builder newTabGroup: {
		self buildWorkspaceLabel -> self buildWorkspacePanel.
		self buildCodeBrowserLabel -> self buildCodeBrowserPanel.
	}.! !

!PharoBotUI methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildTransitionsFor: browser

	self subclassResponsibility! !

!PharoBotUI methodsFor: 'ui building - morphic' stamp: 'NahuelGarbezza 8/26/2012 18:36'!
buildWorkspaceLabel

	^builder newRow: {
		builder newImage: PharoBotIcons workspaceAreaIcon.
		builder newLabel: 'Pruebas'.
	}! !

!PharoBotUI methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/26/2012 19:31'!
buildWorkspacePanel

	|browser|
	browser := GLMTabulator new.
	browser
		row: #world span: 6;
		row: [ :row | row
			column: #workspaces span: 3;
			column: #currentWorkspace span: 4;
			column: #variables span: 3.
		] span: 4.
	
	browser transmit to: #world; andShow: [ :p |
		p morph display: [ self buildWorldArea ]
	].
	
	browser transmit to: #workspaces; andShow: [ :p |
		p list
			title: 'Workspaces';
			display: #workspaces;
			act: [ self createNewWorkspace ]
				icon: PharoBotIcons addWorkspaceIcon
				entitled: 'Agregar nuevo Workspace';
			act: [ self removeSelectedWorkspace ]
				icon: PharoBotIcons removeWorkspaceIcon
				entitled: 'Eliminar Workspace';
			act: [ self renameSelectedWorkspace ]
				icon: PharoBotIcons renameWorkspaceIcon
				entitled: 'Renombrar Workspace';
			act: [ self importWorkspace ]
				icon: PharoBotIcons importWorkspaceIcon
				entitled: 'Importar desde archivo';
			act: [ self exportSelectedWorkspace ]
				icon: PharoBotIcons exportWorkspaceIcon
				entitled: 'Exportar a un archivo' ].
	
	browser transmit from: #workspaces; to: #currentWorkspace; andShow: [ :p |
		p morph display: [ :pharoBotWorkspace |
			PharoBotWorkspaceAdaptor new
				workspaceModel: pharoBotWorkspace;
				buildTextMorph ]	].
	
	browser transmit
		from: #workspaces;
		to: #variables;
		andShow: [ :p | p table
			title: 'Referencias';
			display: [ :w | w variableBindings associations ];
			column: 'Referencia' evaluated: #key;
			column: 'Valor' evaluated: [ :a | a value printString ];
			act: [ self inspectCurrentVariable ]
				icon: PharoBotIcons inspectReferenceIcon
				entitled: 'Inspeccionar';
			act: [ :t | self removeCurrentVariable ]
				icon: PharoBotIcons removeReferenceIcon
				entitled: 'Eliminar referencia' ].
		
	^self startBrowser: browser! !

!PharoBotUI methodsFor: 'ui building - morphic' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildWorldArea

	"TODO eliminar codigo de prueba"
	| world laBateria elRobot elMundo sp |
	world := Mundo crearMundo: 560@560.
	laBateria:= Bateria crearBateriaConCargaMaxima: 1000.
	elRobot:= RobotMorph crearRobotConMundo: world conBateria: laBateria. 
	elRobot inicializarRobot.
	sp := ScrollPane new.
	sp scroller addMorph: world.
	^sp! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:43'!
closeWindow

	"Advertir que se pierden cambios: robots, variables inicializadas, workspaces. No se pierden metodos y clases creados"
	"Luego, cerrar la ventana"
	self flag: #TODO.
	self shouldBeImplemented.! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:43'!
createNewWorkspace

	"Pregunta con un popup el nombre, y luego lo agrega y switchea a ese nuevo workspace"
	self flag: #TODO.
	self shouldBeImplemented.! !

!PharoBotUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 8/26/2012 19:25'!
currentClassSelected

	self subclassResponsibility! !

!PharoBotUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
environment

	^environment! !

!PharoBotUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
environmentClass

	self subclassResponsibility! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:43'!
exportSelectedWorkspace

	"Exporta el contenido del workspace a un archivo"
	"Luego, se muestra un cartel diciendo si se exporto correctamente y si no, mostrar el error (por ejemplo, falta de permisos en el disco)"
	"Puede asumirse la convencion nombre archivo == nombre del workspace"
	"Tener en cuenta que se debe lanzar una advertencia si ningun workspace esta seleccionado"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:44'!
importWorkspace

	"Importa el contenido del workspace de un archivo y lo agrega"
	"Luego, se muestra un cartel diciendo si se importo correctamente y si no, mostrar el error (por ejemplo, falta de permisos en el disco)"
	"Puede asumirse la convencion nombre archivo == nombre del workspace"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:44'!
inspectCurrentVariable

	"Abre un inspector (objeto inspect) de la variable seleccionada"
	"Tener en cuenta que se debe lanzar una advertencia si ninguna variable esta seleccionada"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 8/26/2012 00:44'!
methodBrowser

	^methodBrowser! !

!PharoBotUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 8/26/2012 19:45'!
methodsInCategoryForCurrentClass: category

	^self currentClassSelected methods
		select: [ :m | m category == category ]
		thenCollect: #selector! !

!PharoBotUI methodsFor: 'ui opening' stamp: 'NahuelGarbezza 8/26/2012 00:41'!
open

	environment := self environmentClass new.
	methodBrowser := Browser new.
	^(self buildMainPanel openInWindowLabeled: 'PharoBot') fullscreen; yourself! !

!PharoBotUI methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/26/2012 18:58'!
presentInstanceMethodsOn: presentation title: title

	^presentation list
		title: title;
		display: [ :cat | self methodsInCategoryForCurrentClass: cat ];
		act: [ self addNewInstanceMethod ]
			icon: PharoBotIcons addMethodIcon
			entitled: 'Nuevo';
		act: [ self removeSelectedInstanceMethod ]
			icon: PharoBotIcons removeMethodIcon
			entitled: 'Eliminar';
		act: [ self renameSelectedInstanceMethod ]
			icon: PharoBotIcons renameMethodIcon
			entitled: 'Renombrar'! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:44'!
quit

	"Preguntar si se desea salir PERDIENDO TODOS LOS CAMBIOS HASTA EL ULTIMO SAVE"
	"Luego, cerrar la imagen (guardar o no dependiendo de lo que el usuario eligio)"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:44'!
removeCurrentVariable

	"Elimina la variable seleccionada del workspace. Advierte que se pierde el valor"
	"Tener en cuenta que se debe lanzar una advertencia si ninguna variable esta seleccionada"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:13'!
removeSelectedInstanceMethod

	"Pedir confirmacin, luego eliminarlo"
	"Interactuar con PharoBotGlobalEnvironment"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:44'!
removeSelectedWorkspace

	"Pide confirmacion primero. Se pierden las variables inicializadas y obviamente el contenido del workspace"
	"Tener en cuenta que se debe lanzar una advertencia si ningun workspace esta seleccionado"
	self flag: #TODO.
	self shouldBeImplemented.! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:44'!
renameSelectedInstanceMethod

	"Pide nuevo nombre con un popup, y lo renombra"
	"Tener en cuenta que se debe lanzar una advertencia si ningun metodo esta seleccionado"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:44'!
renameSelectedWorkspace

	"Pide nuevo nombre con un popup, y lo renombra"
	"Tener en cuenta que se debe lanzar una advertencia si ningun workspace esta seleccionado"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 18:44'!
saveImage

	"Solo guardar la imagen. Si hay alguna forma no molesta de notificar que se guardo correctamente, se puede agregar"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'private' stamp: 'NahuelGarbezza 8/26/2012 18:45'!
startBrowser: browser

	^(browser startOn: self environment)
		renderGlamorouslyOn: GLMMorphicRenderer new! !

PharoBotUI subclass: #PharoBotUIWithClasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:14'!
addNewClassMethod

	"Popup pidiendo el nombre del metodo, y setearlo como seleccionado."
	"Por defecto, compilarlo con el nombre y un comentario a modo de template"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUIWithClasses methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/21/2012 00:14'!
buildLayoutFor: browser
	
	browser
		row: [ :row |
			row
				column: #classes span: 3;
				column: #categories span: 3;
				column: #methods span: 4 ] span: 4;
		row: #code span: 6.! !

!PharoBotUIWithClasses methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/21/2012 00:12'!
buildTransitionsFor: browser

	self buildTransitionsForClasses: browser.
	self buildTransitionsForCategories: browser.
	self buildTransitionsForInstanceAndClassMethods: browser.
	self buildTransitionsForCodeEditor: browser.! !

!PharoBotUIWithClasses methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/21/2012 00:08'!
buildTransitionsForCategories: browser

	browser transmit
		from: #classes;
		to: #categories;
		andShow: [ :p |
			p list
				title: 'Categorias';
				display: #protocols ]! !

!PharoBotUIWithClasses methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/26/2012 18:50'!
buildTransitionsForClasses: browser

	browser transmit
		to: #classes;
		andShow: [ :p | 
			p list
				title: 'Clases';
				display: #classes;
				act: [ self createNewClass ]
					icon: PharoBotIcons addClassIcon
					entitled: 'Nueva';
				act: [ self removeSelectedClass ]
					icon: PharoBotIcons removeClassIcon
					entitled: 'Eliminar';
				act: [ self exportSelectedClass ]
					icon: PharoBotIcons renameClassIcon
					entitled: 'Renombrar';
				act: [ self importClass ]
					icon: PharoBotIcons importClassIcon
					entitled: 'Importar';
				act: [ self exportSelectedClass ]
					icon: PharoBotIcons exportClassIcon
					entitled: 'Exportar' ]! !

!PharoBotUIWithClasses methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/26/2012 00:44'!
buildTransitionsForCodeEditor: browser

	browser transmit
		from: #methods;
		to: #code;
		andShow: [ :p |
			p morph
				title: 'Implementacion';
				display: [ :selector | 
					| class |
					class := PharoBotGlobalEnvironment instance robotClass.
					self methodBrowser
						setClass: class selector: selector;
						buildTextMorph ] ]! !

!PharoBotUIWithClasses methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/26/2012 19:34'!
buildTransitionsForInstanceAndClassMethods: browser

	browser transmit
		from: #categories;
		to: #methods;
		andShow: [ :p | 
			self presentInstanceMethodsOn: p title: 'Metodos de instancia'.
			self presentClassMethodsOn: p title: 'Metodos de clase'.
		].! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:11'!
createNewClass

	"Pedir nombre con un popup, crearla (Llamar a PharoBotGlobalEnvironment)"
	"y agregarla a la lista de clases del ambiente (ideal con Announcements)"
	self flag: #TODO.
	self shouldBeImplemented.! !

!PharoBotUIWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 8/20/2012 19:54'!
environmentClass

	^PharoBotEnvironmentWithClasses! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:09'!
exportSelectedClass

	"exportar clase seleccionada por fileout, pedir nombre de archivo"

	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:10'!
importClass

	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUIWithClasses methodsFor: 'ui building - glamour' stamp: 'NahuelGarbezza 8/26/2012 19:04'!
presentClassMethodsOn: presentation title: title

	presentation list
		title: title;
			display: [ :category | self classMethodsInCategory: category ];
			act: [ self addNewClassMethod ]
				icon: PharoBotIcons addMethodIcon
				entitled: 'Agregar';
			act: [ self removeClassMethod ]
				icon: PharoBotIcons removeMethodIcon
				entitled: 'Eliminar metodo';
			act: [ self renameClassMethod ]
				icon: PharoBotIcons renameMethodIcon
				entitled: 'Eliminar metodo'! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:10'!
removeSelectedClass

	self flag: #TODO.
	self shouldBeImplemented.! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:14'!
removeSelectedClassMethod

	"Pedir confirmacin, luego eliminarlo"
	"Interactuar con PharoBotGlobalEnvironment"
	self flag: #TODO.
	self shouldBeImplemented! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 8/26/2012 19:14'!
renameSelectedClassMethod

	"Pide nuevo nombre con un popup, y lo renombra"
	"Tener en cuenta que se debe lanzar una advertencia si ningun metodo esta seleccionado"
	self flag: #TODO.
	self shouldBeImplemented! !

PharoBotUI subclass: #PharoBotUIWithObjects
	instanceVariableNames: 'currentMethodSelected currentMethodTextMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 8/20/2012 19:35'!
buildLayoutFor: browser

	browser
		row: [ :row | row column: #categories; column: #instanceMethods ] span: 4;
		row: #code span: 6! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 8/20/2012 19:21'!
buildTransitionsFor: browser

	self buildTransitionsForCategories: browser.
	self buildTransitionsForInstanceMethods: browser.
	self buildTransitionsForCodeEditor: browser! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 8/20/2012 19:31'!
buildTransitionsForCategories: browser

	browser transmit
		to: #categories;
		andShow: [ :p |
			p list
				title: 'Categorias';
				display: #categories ]! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 8/26/2012 19:27'!
buildTransitionsForCodeEditor: browser

	browser transmit
		from: #instanceMethods;
		to: #code;
		andShow: [ :p | self presentCodeEditorOn: p ]! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 8/26/2012 18:52'!
buildTransitionsForInstanceMethods: browser

	browser transmit
		from: #categories;
		to: #instanceMethods;
		andShow: [ :p | self presentInstanceMethodsOn: p title: 'Metodos' ]! !

!PharoBotUIWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 8/26/2012 19:25'!
currentClassSelected

	^PharoBotGlobalEnvironment instance robotClass! !

!PharoBotUIWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
environmentClass

	^PharoBotEnvironmentWithObjects! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 8/26/2012 19:30'!
presentCodeEditorOn: presentation

	presentation morph
		title: 'Implementacion';
		display: [ :selector | 
			| class |
			class := PharoBotGlobalEnvironment instance robotClass.
			selector == currentMethodSelected
				ifFalse: [
					self methodBrowser setClass: class selector: selector.
					currentMethodTextMorph := self methodBrowser buildTextMorph.
							currentMethodSelected := selector ].
					currentMethodTextMorph ]! !
